import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Aplic extends JFrame implements ActionListener
{
  MonsterList ml = new MonsterList(30);

  public Aplic()
  {
    super();

    JButton butmove  = new JButton("Move");
    JButton butsmove = new JButton("SmartMove");
    butmove.addActionListener(this);
    butsmove.addActionListener(this);
    
    JPanel bots = new JPanel();
    bots.add(butmove);
    bots.add(butsmove);
    
    Tela tela = new Tela(ml);

    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(tela,BorderLayout.CENTER);
    getContentPane().add(bots,BorderLayout.SOUTH);

    // cria 10 monstros de cada tipo
    for(int i=0; i<10; ++i)
    {
      ml.insere(new Monster(500,500,null));
      ml.insere(new FastMonster(500,500,null));
      ml.insere(new SlowMonster(500,500,null));
    }
  }

  public void actionPerformed(ActionEvent e)
  {
	boolean intelligent;	// true = movimento inteligente
	String action = e.getActionCommand();
	if(action.equals("Move")) intelligent = false;
	else intelligent = true;
	for(int i=0;i<ml.quant();++i)
	  if(intelligent) ml.get(i).smartMove(ml);
	    else ml.get(i).move();
	repaint();
  }
   
  public static void main(String args[])
  {
     Aplic frame = new Aplic();
     frame.addWindowListener(new WindowAdapter() {
	public void windowClosing(WindowEvent e) { System.exit(0); }});
     frame.pack();
     frame.show();
  }
}
