import java.awt.*;

class Monster extends OldMonster implements SmartMonster
{
  public Monster(int larg,int alt, Image fig)
  {
    super(larg,alt,fig);
  }
 
  public void smartMove(MonsterList ml)
  {
    double proxdist = 100000;
    Point pos = new Point(x,y);	// coordenadas do monstro
    Monster proxmonst = null;		// monstro mais prximo

    for(int i=0; i<ml.quant();++i)
    {
      Monster m = ml.get(i);  // obtm referncia

      if(m==this) continue;	// se for o mesmo, no pode testar
	double dist = pos.distance(m.x,m.y); // calcula distncia
	if (dist<mindist) continue; 	// dist. menor que a mnima, ignora
	if (dist>proxdist) continue; // dist. maior que a menor encontrada

	proxdist = dist;	// armazena menor distncia
	proxmonst = m;	// armazena monstro mais prximo
    }

    if(proxmonst == null) move(); // ningum, usa a move()
    else
    {
	int deltax = proxmonst.x - x;	  // calc diferena entre os x
	int deltay = proxmonst.y - y;	  // calc diferena entre os y
	if(deltax<0) x-=retornaVel();	  // menor que 0 = andar p/ esquerda
	if(deltax>0) x+=retornaVel();	  // maior que 0 = andar p/ direita
	if(deltay<0) y-=retornaVel();     // menor que 0 = andar p/ cima
	if(deltay>0) y+=retornaVel();     // maior que 0 = andar p/ baixo

      // Verifica se passou dos limites da janela, ajusta de acordo
      if (x<0) x=0;
      if (y<0) y=0;
      if (x>largCampo) x=largCampo-1;
      if (y>altCampo)  y=altCampo-1;
    }
  }
}

 