import java.util.*;
import java.awt.*;

class OldMonster
{
  int x,y;
  int largCampo, altCampo;
  Image figura;
  static Random r = null;

  // Construtor recebe dimenses da tela e a imagem a desenhar
  public OldMonster(int larg,int alt, Image fig)
  {
    if(r==null) r = new Random();
    largCampo = larg;
    altCampo = alt;
    x = r.nextInt(largCampo);
    y = r.nextInt(altCampo);
    figura = fig;
  }

  public int retornaVel()
  {
     return(5);
  }

  public void move()
  {
    // sorteia direo para movimento
    boolean dirx = r.nextBoolean();
    boolean diry = r.nextBoolean();
    // Avana na direo escolhida
    if (dirx) x+= retornaVel();
      else x-= retornaVel();
    if (diry) y+= retornaVel();
      else y-= retornaVel();
    // Testa se no estourou os limites
    if (x<0) x=0;
    if (y<0) y=0;
    if (x>largCampo) x=largCampo-1;
    if (y>altCampo)  y=altCampo-1;
  }

  public void draw(Graphics g)
  {
//    g.drawImage(...);
      g.setColor(Color.blue);
      g.drawOval(x-5,y-5,10,10);
  }
}
